/**
 * Copyright (c) 2005 JavaPlant Software.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.javaplant.portlets;

import java.util.ArrayList;
import com.javaplant.portlet.PortletForm;

/**
 * @author Brad Smith <mvcportlet@gmail.com>
 *         Date: Sep 18, 2005
 */
public class RSSFeedPortletForm extends PortletForm  {

    private String rowNumber = "";
    private ArrayList rssFeeds = new ArrayList();// THIS HOLDS THE CONTENT OF A FEED
    private RSSFeedConfiguration rssFeedConfiguration = new RSSFeedConfiguration();
    private boolean loadPortletPreferences = true;

    public boolean validate() {
        return true;
    }

    public String getRowNumber() {
        return rowNumber;
    }

    public void setRowNumber(String rowNumber) {
        this.rowNumber = rowNumber;
    }

    public ArrayList getRssFeeds() {
        return rssFeeds;
    }

    public void setRssFeeds(ArrayList rssFeeds) {
        this.rssFeeds.clear();
        if (rssFeeds != null) {
            this.rssFeeds.addAll(rssFeeds);
        }
    }

    public final void addRssFeedContent(String feedContent) {
        if (feedContent != null) {
            this.rssFeeds.add(feedContent);
        }
    }

    public final RSSFeedConfiguration getRssFeedConfiguration() {
        return rssFeedConfiguration;
    }

    public final void setRssFeedConfiguration(RSSFeedConfiguration rssFeedConfiguration) {
        this.rssFeedConfiguration = rssFeedConfiguration;
    }

    public boolean isLoadPortletPreferences() {
        return loadPortletPreferences;
    }

    public void setLoadPortletPreferences(boolean loadPortletPreferences) {
        this.loadPortletPreferences = loadPortletPreferences;
    }

    public String toString() {
        final StringBuffer buf = new StringBuffer();
        buf.append(super.toString()).append(" ::: ");
        buf.append("RSSFeedPortletForm");
        buf.append("{rowNumber=").append(rowNumber);
        buf.append(",rssFeeds=").append(rssFeeds);
        buf.append(",rssFeedConfiguration=").append(rssFeedConfiguration);
        buf.append('}');
        return buf.toString();
    }
}
