<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="portlet" uri="http://java.sun.com/portlet" %>
<%@ taglib prefix="jp-portlet" uri="/WEB-INF/lib/jp-mvc-portlet-fwk-1.0.jar" %>

<%-- Use this page as a starter or template page for all your portlet JSP pages. --%>

<%-- The following two tags are used to 'transfer' the
     portletForm from renderRequest scope to page scope.
     JSTL and other JSP custom tags no nothing about the
     various portlet scopes. --%>

<portlet:defineObjects/>
<jp-portlet:portletForm/>

<%-- The result of these two tags is that now, there is
     a PortletForm (or subclass of PortletForm) available in
     page-scope under the key "portletForm".  Thus, properties
     of the 'form bean' can be accessed via the JSP expression
     language like so:

     ${portletForm.someProperty}  and ${portletForm.anotherProperty}

--%>
<c:set var="saveRssPrefsURL"><portlet:actionURL><portlet:param name="action" value="savePrefs"/></portlet:actionURL></c:set>
<c:set var="removeRowURL"><portlet:actionURL><portlet:param name="action" value="removeRow"/></portlet:actionURL></c:set>
<c:set var="addRowURL"><portlet:actionURL><portlet:param name="action" value="addRow"/></portlet:actionURL></c:set>
<c:set var="cancelURL"><portlet:actionURL><portlet:param name="action" value="cancel"/></portlet:actionURL></c:set>
<style type="text/css">
label{font-family:sans-serif;font-size:11px;font-weight:bold;width:28em;}
</style>
<script type="text/javascript" language="javascript">
// trim whitespace from ends of string (t)
_jp_re_ws=/\s/
function trim(t){
  if(!t)return '';
  if(typeof(t)!='string')return t;
  while(t.charAt(0).match(_jp_re_ws))t=t.substr(1);
  while(t.charAt(t.length-1).match(_jp_re_ws))t=t.substring(0,t.length-1);
  return t;
}

function endsWith(str,end) {
  if (str && end) {
    sLen = str.length;
    eLen = end.length;
    if (eLen < sLen) {
      return (str.substring(sLen-eLen) == end);
    }
  }
  return false;
}

function startsWith(str,pre) {
  if (str && pre) {
    sLen = str.length;
    pLen = pre.length;
    if (pLen < sLen) {
      return (str.substring(0,pLen)==pre);
    }
  }
  return false;
}

function toggleField(toggle,fieldName) {
  if (toggle && fieldName && toggle.form.elements[fieldName]) {
    if (toggle.checked) {
      fName = fieldName.substring(5);
      if (toggle.form.elements[fName].value != toggle.form.elements[fieldName].value) {
        if (confirm("Keep changes?")) {
          toggle.form.elements[fName].value = toggle.form.elements[fieldName].value;
        } else {
          toggle.form.elements[fieldName].value = toggle.form.elements[fName].value;
        }
      }
    }
    toggle.form.elements[fieldName].disabled = toggle.checked;
  }
}

function removeLink(rowButton){
  if (rowButton && rowButton.form && rowButton.form.elements['rowNumber']) {
    rowButton.form.elements['rowNumber'].value = rowButton.name;
    rowButton.form.action='${removeRowURL}';
    rowButton.form.submit();
  }
}

function addRow(button){
  if (button && button.form) {
    button.form.action='${addRowURL}';
    button.form.submit();
  }
}

function cancel(button){
  if (button && button.form) {
    button.form.action='${cancelURL}';
    button.form.submit();
  }
}

function validate(form) {
  if (form) {
    // check XSLT value
    xslField = form.elements['edit.rssFeedConfiguration.xsl'];
    if (xslField && xslField.value) {
      xslField.value = trim(xslField.value);
      if (!xslField.value) {
        alert("ERROR:  You must supply the filepath to an XSLT file\n        that is deployed within this web application");
        return false;
      } else if (!endsWith(xslField.value,'.xsl')) {
        alert("ERROR:  The XSLT file name does not end with '.xsl'.\n"
             +"        Example - myrssstylesheet.xsl");
        return false;
      } else if (xslField.value == '.xsl') {
        // error - invalid file name for XSLT file
        alert("ERROR:  '"+xslField.value+"' is not a valid filename for the XSLT file.");
        return false;
      }
    }
    // check timeout value
    //
    return true;
  }
}

var formRef;
var timerRef=0;
// validate and submit form
function preSubmitForm(form) {
  if (form && validate(form)) {
    // NOTE:  if I remove the var below, this function will generate an error
    //        on IE 6.0.2800.1106  SP1, Q823353 on Windows 2000
    var editForm = document.getElementById("editForm");
    var busyImg = document.getElementById("busy");
    if (editForm && busyImg) {
      formRef = form
      editForm.style.display = 'none';
      busyImg.style.display = 'inline';
      timerRef = setTimeout("submitForm()",1500);
    }
    return false;
  }
}

function submitForm() {
  if (formRef && timerRef) {
    clearTimeout(timerRef);
    formRef.submit();
  }
}
</script>
Edit Mode
<div id="editForm" style="display:inline;">
<form name="editRssPrefs" action="${saveRssPrefsURL}"
      method="post" enctype="application/x-www-form-urlencoded"
      onsubmit="return preSubmitForm(this);">
<div>
  <div><b>RSS Feed URL's:</b></div>
  <c:forEach items="${portletForm.rssFeedConfiguration.rssURLs}" var="rssURL" varStatus="loopStatus">
  <div id="feed_${loopStatus.index}">
    <label>Feed ${loopStatus.index}</label>
  <input type="text" name="rssFeedConfiguration.rssURL[${loopStatus.index}]" value="${rssURL}" size="66" maxlength="255" style="font-size:9px;"/>
<%--c:choose>
  <c:when test="${!loopStatus.first}"><input type="button" name="moveFeedUp_${loopStatus.index}" value="&Delta;" title="Move Feed Up" /></c:when>
  <c:otherwise>&nbsp;&nbsp;&nbsp;</c:otherwise>
</c:choose>
<c:choose>
  <c:when test="${!loopStatus.last}"><input type="button" name="moveFeedDown_${loopStatus.index}" value="&nabla;" title="Move Feed Down" /></c:when>
  <c:otherwise>&nbsp;&nbsp;&nbsp;</c:otherwise>
</c:choose--%>
  <input type="button" name="${loopStatus.index}" value=" remove " title="Remove Feed" onclick="removeLink(this);"/>
  </div>
  </c:forEach>
  <input type="button" name="addFeed" value=" + Add a Feed " onclick="addRow(this);"/>&nbsp;&nbsp;&nbsp;
</div>
<hr />
Settings:
<div>
  <label title="This value sets how much time the portlet will allow to elapse for a single RSS-feed request.">timeout:</label>
  <input type="text" name="rssFeedConfiguration.timeout" value="${portletForm.rssFeedConfiguration.timeout}" size="5" maxlength="4" style="text-align:right;"/> seconds
</div>
<div>
  <label title="This is the path within this web application where an .xsl file is obtained to transform each RSS Feed.">XSLT:</label>
  <input type="text" name="edit.rssFeedConfiguration.xsl" value="${portletForm.rssFeedConfiguration.xsl}" size="28" maxlength="255" disabled="true"/>
  <input type="checkbox" name="lockXsl" value="true" checked="true" title="Uncheck this box to edit the httpProxyPort value." onclick="toggleField(this,'edit.rssFeedConfiguration.xsl');"/> locked
</div>
<div>
  <label title="Your network configuration may require you to use an HTTP proxy; set it's address here.">httpProxyHost:</label>
  <input type="text" name="edit.rssFeedConfiguration.httpProxyHost" value="${portletForm.rssFeedConfiguration.httpProxyHost}" size="28" maxlength="255" disabled="true"/>
  <input type="checkbox" name="lockhttpProxyHost" value="true" checked="true" title="Uncheck this box to edit the httpProxyHost value." onclick="toggleField(this,'edit.rssFeedConfiguration.httpProxyHost');"/> locked
</div>
<div>
  <label title="Your network configuration may require you to use an HTTP proxy; set it's port here - default is often port 80.">httpProxyPort:</label>
  <input type="text" name="edit.rssFeedConfiguration.httpProxyPort" value="${portletForm.rssFeedConfiguration.httpProxyPort}" size="28" maxlength="255" disabled="true"/>
  <input type="checkbox" name="lockhttpProxyPort" value="true" checked="true" title="Uncheck this box to edit the httpProxyPort value." onclick="toggleField(this,'edit.rssFeedConfiguration.httpProxyPort');"/> locked
</div>
<div>
<input type="hidden" name="rssFeedConfiguration.xsl" value="${portletForm.rssFeedConfiguration.xsl}"/>
<input type="hidden" name="rssFeedConfiguration.httpProxyHost" value="${portletForm.rssFeedConfiguration.httpProxyHost}"/>
<input type="hidden" name="rssFeedConfiguration.httpProxyPort" value="${portletForm.rssFeedConfiguration.httpProxyPort}"/>
<input type="hidden" name="rowNumber" value=""/><%-- row number we are operating on --%>
<input type="submit" value=" Save Changes " style="background-color:#EBD6FF;"/>&nbsp;&nbsp;&nbsp;<input type="button" value=" Cancel " onclick="cancel(this);" style="background-color:#EBD6FF;"/>

</div>
</form>
</div>
<div id="busy" style="display:none;">
<img src="<c:url value="/img/Gears_spin.gif"/>" border="0"/><span style="font-size:15px;font-weight:bold;">Saving...</span>
</div>