<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE xsl:stylesheet [
    <!ENTITY nbsp "&#160;">
    <!ENTITY copy "&#169;">
]>
<!--
    Document   : rss-2.0.xsl
    Created on : September 8, 2005
    Author     : Brad Smith <mvcportlet@gmail.com>
    Description:
        Transform RSS-2.0 Feed
-->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:jsp="http://java.sun.com/JSP/Page">
<xsl:output method="xml" omit-xml-declaration="yes" indent="yes"/>
  <!-- TODO customize transformation rules
         syntax recommendation http://www.w3.org/TR/xslt
  -->
<xsl:preserve-space elements="*" />
<xsl:template match="/">
<style type="text/css">
.rssChannel {
 font-family:sans-serif;font-size:11px;font-color:black;background-color#F7EFDB;
 border:1px solid #F7EFDB;
}
.rssChannelTitle {
 font-weight:bold;font-size:12px;background-color:#c3daf4;
  padding: 2px 3px 2px 3px;width:100%;
}
.rssItem {
 font-size:10px;
 margin-top:10px;
 padding: 2px 5px 2px 5px;
}
.rssLink {
 font-weight:bold;color:blue;
}
a.rssLink:hover {
  color:red;
  text-decoration:underline;
  font-weight:bold;
}
.rssDescription {
 font-size:9px;
}
</style>
  <xsl:apply-templates select="rss/channel"/>
</xsl:template>

<xsl:template match="channel">
<div id="" class="rssChannel">
  <div class="rssChannelTitle"><xsl:value-of select="title"/></div>
  <xsl:apply-templates select="item"/>
</div>
</xsl:template>

<xsl:template match="item">
  <div class="rssItem">
  <a href="#" class="rssLink">
    <xsl:attribute name="onclick">
      <xsl:text><![CDATA[window.open(']]></xsl:text>
      <xsl:value-of select="link"/>
      <xsl:text><![CDATA[');]]></xsl:text>
    </xsl:attribute>
    <span class="rssLink"><xsl:value-of select="title"/></span>
  </a>
  <br />
  <span class="rssDescription">
    <xsl:value-of select="description" disable-output-escaping="yes"/>
  </span>
  </div>
</xsl:template>

</xsl:stylesheet>
