/**
 * Copyright (c) 2005 JavaPlant Software.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.javaplant.portlet;

/** This class provides some basic Inter- / Intra- portlet communication.
 *  - PortletForm for action portlet is available to all portlets that participate in a request.
 *  - action portlet's name is available to all portlets that participate in a request.
 * 
 * @author Brad Smith <mvcportlet@gmail.com>
 *         Date: Aug 14, 2005
 */
final class PortletProcessingContext {

    private String actionPortletName = "";
    private PortletForm actionForm;

    public final PortletForm getActionForm() {
        return actionForm;
    }

    public final void setActionForm(PortletForm actionForm) {
        this.actionForm = actionForm;
    }

    public final String getActionPortletName() {
        return actionPortletName;
    }

    public final void setActionPortletName(String actionPortletName) {
        this.actionPortletName = (actionPortletName==null)?"":actionPortletName;
    }

    public String toString() {
        final StringBuffer buf = new StringBuffer();
        buf.append("PortletProcessingContext");
        buf.append("{actionPortletName=").append(actionPortletName);
        buf.append(",actionForm=").append(actionForm);
        buf.append('}');
        return buf.toString();
    }
}
